//+------------------------------------------------------------------+
//|                                                   ReadWebCSV.mq4 |
//|                                                           Ramdas |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property library


#import "wininet.dll"
  int InternetAttemptConnect (int x);
  int InternetOpenA(string sAgent, int lAccessType, 
                    string sProxyName = "", string sProxyBypass = "", 
                    int lFlags = 0);
  int InternetOpenUrlA(int hInternetSession, string sUrl, 
                       string sHeaders = "", int lHeadersLength = 0,
                       int lFlags = 0, int lContext = 0);
  int InternetReadFile(int hFile, int& sBuffer[], int lNumBytesToRead, 
                       int& lNumberOfBytesRead[]);
  int InternetCloseHandle(int hInet);
#import

//+------------------------------------------------------------------+
//| ReadWebPage and return data                                                      |
//+------------------------------------------------------------------+

string ReadWebPage(string stkname,string url, bool makeCSV )
 {
      if(!IsDllsAllowed())                      // Check if DLL Allow is enable in MT4 Options 
   {
      Alert("Please allow DLL imports");
      return("");
   }
   
    if(url == "")                      // Check if DLL Allow is enable in MT4 Options 
   {
      Alert("Blank URL");
      return("");
   }
   
   int result = InternetAttemptConnect(0);      // Internet Connect Attemp 
   if(result != 0)
   {
      Alert("Cannot connect to internet - InternetAttemptConnect()");
      return("");
   }
   
   int hInternetSession = InternetOpenA("Microsoft Internet Explorer", 0, "", "", 0);
   if(hInternetSession <= 0)
   {
       Alert("Cannot open internet session - InternetOpenA()");
       return("");         
   }
   int hURL = InternetOpenUrlA(hInternetSession,                   //Open internet URL
              url, "", 0, 0, 0);
   if(hURL <= 0)
     {
       Alert("Cannot open URL ", url, " - InternetOpenUrlA()");
       InternetCloseHandle(hInternetSession);
       return("");         
     }      
                                                                    //Ready to read internet data    
   int cBuffer[256];
   int dwBytesRead[1]; 
   string WebData = "";
   
   while(!IsStopped())
   {
      for(int i = 0; i<256; i++) cBuffer[i] = 0;
      bool bResult = InternetReadFile(hURL, cBuffer, 1024, dwBytesRead);
      
      if(dwBytesRead[0] == 0) break;
      
      string text = "";   
      
      for(i = 0; i < 256; i++)
      {
         text = text + CharToStr(cBuffer[i] &0x000000FF);
         if(StringLen(text) == dwBytesRead[0]) break;
         
         text = text + CharToStr(cBuffer[i] >> 8 &0x000000FF);
         if(StringLen(text) == dwBytesRead[0]) break;
         
         text = text + CharToStr(cBuffer[i] >> 16 &0x000000FF);
         if(StringLen(text) == dwBytesRead[0]) break;
         
         text = text + CharToStr(cBuffer[i] >> 24 &0x000000FF);   
      }
      
      WebData = WebData + text;
      Sleep(1);
   }
      
   InternetCloseHandle(hInternetSession);
        
   if (makeCSV)
     {
     int handle;
     
     FileDelete(stkname+".csv"); 
 
     handle=FileOpen(stkname+".csv", FILE_CSV|FILE_WRITE, ';');
       if(handle>0)
          {
            FileWrite(handle, WebData);
            FileClose(handle);
          }
      }  
   //Comment(WebData); 
   return(WebData);
 
 }