//+------------------------------------------------------------------+
//|                                Script Create Symbol List V10.mq4 |
//|                                                           Ramdas |
//|                                       This is Script             |
//+------------------------------------------------------------------+
// This script creates Symbol file and symbol group file 
//  
#property copyright ""
#property link      ""
#property show_inputs


extern string InputFile = "symbols.txt";
extern string OutputFile = "symbols.raw";
extern string SymGroupOutputFile = "symgroups.raw";

string stk_name[250];
int stkLstCnt = 0; 

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   LoadSymbols();
   MakeSymbolsFile(); 
   
   Alert( " Done.. Restart MT4 and in market watch click show all symbol");
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
// Load symboles from Symbol file and create csv file
//+------------------------------------------------------------------+

int LoadSymbols()
{
   string str;
   int handle;
   stkLstCnt = 0;
      
    handle = FileOpen(InputFile,FILE_READ);
   if(handle < 0) {Alert( InputFile + "  File not present"); return(0);}
   
   if (handle >= 0)
   {
      while (!FileIsEnding(handle))
      {
          str = FileReadString (handle,0);
          if (str == "" || str == " " ) break;
          str = StringTrimRight(str);
          str = StringTrimLeft(str);
          stk_name[stkLstCnt] = str;
          stkLstCnt++;
      }
       
   }
     FileClose(handle);
     return(stkLstCnt); 
}

//+------------------------------------------------------------------+

int MakeSymbolsFile() 
{
    int cnt1;
    string z = CharToStr(0x00);
          
   int rawHandle = FileOpenHistory(OutputFile, FILE_BIN | FILE_WRITE);
   if(rawHandle < 0) {Alert( OutputFile + "  not geting created"); return(0);} 
     
     for (cnt1 = 1; cnt1 <= stkLstCnt; cnt1++)
        {
         FileWriteString(rawHandle, stk_name[cnt1-1], 104);
         FileWriteString(rawHandle, CharToStr(0x02), 4);
         FileWriteString(rawHandle, CharToStr(0x02), 7);
         FileWriteString(rawHandle, CharToStr(0xff), 1);
         FileWriteString(rawHandle, CharToStr(0x01), 1);
         FileWriteString(rawHandle, z, 3);
         FileWriteString(rawHandle, CharToStr(0x10), 1816);
         FileFlush(rawHandle);
        }
     FileClose(rawHandle);
   
       rawHandle = FileOpenHistory(SymGroupOutputFile, FILE_BIN | FILE_WRITE);
       if(rawHandle < 0) {Alert( SymGroupOutputFile + " not geting created"); return(0);} 
         
         FileWriteString(rawHandle, "Nifty", 16);
         FileWriteString(rawHandle, "Nifty Stock", 2544);
         FileFlush(rawHandle);
         FileClose(rawHandle);
   
   return(0);
}
//+------------------------------------------------------------------+

